clear all;
exec jacobi.sci;

// Donnees du probleme :
n = 15;
A = 2*eye(n,n)-diag(ones(n-1,1),1)-diag(ones(n-1,1),-1);
B = 4*eye(n,n)+diag(ones(n-1,1),1)+diag(ones(n-1,1),-1);
xex = ones(n,1); b = A*xex; c = B*xex;
x0 = zeros(n,1);

// Resolution :
x=jacobi(A,b,x0,1e-6,1000);
y=jacobi(B,c,x0,1e-6,1000);
// Calcul de l'erreur et illustration de la convergence
[pA,qA]=size(x); errA=[];
for i=1:qA
  errA=[errA,norm(xex-x(:,i))];
end
[pB,qB]=size(y); errB=[];
for i=1:qB
  errB=[errB,norm(xex-y(:,i))];
end
scf(1); clf();
plot2d((1:qA)',errA,logflag="nl")
plot2d((1:qB)',errB,logflag="nl")
title(['Courbe de convergence (Jacobi), n='+string(n)])
xlabel('Iteration')
ylabel('log(Erreur)')


disp('Taux de convergence estime : ')
[a,a2,sig]=reglin(1:q,log(err));
disp(exp(a))
disp('Rayon spectral de la matrice des iterations : ')
D=A.*eye(A);
disp(max(abs(spec(eye(n,n)-inv(D)*A))))








exec jacobi_relax.sci;

// Test Jacobi relaxé
omegas=linspace(0,4/3,51);
omegas=omegas(2:length(omegas));
taux=[];
rhospec=[];
for omega=omegas
    //xex = rand(n,1);
    //xex = xex/norm(xex);
    //b=A*xex;
    x=jacobi_relax(omega,A,b,x0,1e-12,200);
    [p,q]=size(x);
    err=[];
    for i=1:q
      err=[err,norm(xex-x(:,i))+%eps];
    end
    //figure(1)
    //plot2d((1:q)',err,logflag="nl");
    //title('Courbe de convergence (échelle log en ordonnée)')
    //xlabel('Itération')
    //ylabel('Erreur')
    [a,a2,sig]=reglin(1:q,log(err));
    taux=[taux;exp(a)];
    rhospec=[rhospec;max(abs(spec(eye(A)-omega*inv(A.*eye(A))*A)))];
end


scf(2)
plot2d(omegas,[taux,rhospec])
title('Taux de convergence en fonction de \omega')
xlabel('omega')
ylabel('Taux de convergence')




// Test Jacobi-relaxé
[xR]=jacobi_relax(0.95,A,b,x0,1e-6,22);
[p,q]=size(xR);
err=[];
for i=1:q
  err=[err,norm(xex-xR(:,i))];
end

scf(1)
plot2d((1:q)',err,logflag="nl")
[a,a2,sig]=reglin(1:q,log(err));
title('Courbe de convergence (échelle log en ordonnée)')
xlabel('Itération')
ylabel('Erreur')



// Test Chebyshev-Jacobi

exec chebyshev_jacobi.sci;

m1=-0.5;
m2=0.5;
[xC,SIGMA]=chebyshev_jacobi(A,b,x0,1e-15,30,m1,m2);
[p,q]=size(xC);
err=[];
for i=1:q
  err=[err,norm(xex-xC(:,i))];
end

scf(1)
plot2d((1:q)',err,logflag="nl")
[a,a2,sig]=reglin(1:q,log(err));
title('Courbe de convergence (échelle log en ordonnée)')
xlabel('Itération')
ylabel('Erreur')



